
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>android画图之贝塞尔曲线讲解 / iVAN</title>

    <meta name="description" content="android画图之贝塞尔曲线讲解 首先对于&lt;赛贝尔曲线&gt;不是很了解的童鞋,请自觉白度百科.google等等...   为了方便偷懒的童鞋,这里给个&lt;贝赛尔曲线&gt;百科地址,以及一段话简述&lt;贝赛尔曲线&gt;: &lt;贝赛尔曲线&gt;白度百科快速地址:http://baike.baidu.com/view/4019466.htm 贝塞尔曲线又称贝兹曲线或贝济埃曲线,一般的矢量图形软件通过它来精确画出曲线,贝兹曲线由线段与节点组成,节点是可拖动的支点,线段像可伸缩的皮筋: 上面这一段话其实就&quot ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">android画图之贝塞尔曲线讲解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>首先对于《赛贝尔曲线》不是很了解的童鞋，请自觉白度百科、google等等...<br />
<br /> </p>
<p>为了方便偷懒的童鞋，这里给个《贝赛尔曲线》百科地址，以及一段话简述《贝赛尔曲线》：</p>
<p><strong>《贝赛尔曲线》白度百科快速地址：<a href="http://baike.baidu.com/view/4019466.htm" rel="external nofollow noreferrer">http://baike.baidu.com/view/4019466.htm</a></strong></p>
<p>贝塞尔曲线又称贝兹曲线或贝济埃曲线，一般的矢量图形软件通过它来精确画出曲线，贝兹曲线由线段与节点组成，节点是可拖动的支点，<strong>线段像可伸缩的皮筋；</strong></p>
<p><strong><br /></strong></p>
<p><strong></strong>上面这一段话其实就“<strong>线段像可伸缩的皮筋</strong>”这一句比较重要，也很容易理解；</p>
<p> </p>
<p>        至于贝赛尔曲线的实现，在Android中极其的简单，因为它是Android封装的一个方法，这个能不简单么。。。。。。只不过它隐藏的比较深，它隐藏于Path类中，方法如下：</p>
<p><strong>android.graphics.</strong><strong>Path</strong><strong>.quadTo(float x1, float y1, float x2, float y2)</strong></p>
<p>Since: <a>API Level 1</a></p>
<p>此方参数解释：</p>
<p>第一个参数：操作点的x坐标</p>
<p>第二个参数：操作点的y坐标</p>
<p>第三个参数：结束点的x坐标</p>
<p>第四个参数：结束点的y坐标</p>
<p>从API中看出，赛贝尔曲线从API－1就开始支持了；</p>
<p> </p>
<p>熟悉方法后，下面就来实现：</p>
<p>SurfaceView框架不多讲，看过我博客的都应该知道的；</p>
<p> </p>
<p>直接看MySurfaceView类，此类继承SurfaceView ，是游戏的主视图</p>
<p> </p>
<p>这里为了更清晰的讲解：这里部分代码先不贴出来了，最后会整体贴出，当然源码也是免费在最后提供～</p>
<p>首先是定义相关的成员变量：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>// 贝赛尔曲线成员变量(起始点，控制（操作点），终止点，3点坐标)  </li>
<li>private int startX, startY, controlX, controlY, endX, endY;  </li>
<li>// Path  </li>
<li>private Path path;  </li>
<li>// 为了不影响主画笔，这里绘制贝赛尔曲线单独用一个新画笔  </li>
<li>private Paint paintQ;  </li>
<li>// 随机库（让贝赛尔曲线更明显）  </li>
<li>private Random random;  </li>
</ol>
<p> <br />
<br />本类构造函数：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>/** </li>
<li> * SurfaceView初始化函数 </li>
<li> */  </li>
<li>public MySurfaceView(Context context) {  </li>
<li>    super(context);  </li>
<li>    ...  </li>
<li>        //贝赛尔曲线相关初始化  </li>
<li>        path = new Path();  </li>
<li>        paintQ = new Paint();  </li>
<li>        paintQ.setAntiAlias(true);  </li>
<li>        paintQ.setStyle(Style.STROKE);  </li>
<li>        paintQ.setStrokeWidth(5);  </li>
<li>        paintQ.setColor(Color.WHITE);  </li>
<li>        random = new Random();  </li>
<li>    ...  </li>
<li>}  </li>
</ol>
<p> <br />
<br />  接着我把绘制贝赛尔曲线封装一个方法了，函数如下：</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>/** </li>
<li> * 绘制贝赛尔曲线 </li>
<li> *  </li>
<li> * @param canvas 主画布 </li>
<li> */  </li>
<li>public void drawQpath(Canvas canvas) {  </li>
<li>    path.reset();// 重置path  </li>
<li>    // 贝赛尔曲线的起始点  </li>
<li>    path.moveTo(startX, startY);  </li>
<li>    // 设置贝赛尔曲线的操作点以及终止点  </li>
<li>    path.quadTo(controlX, controlY, endX, endY);  </li>
<li>    // 绘制贝赛尔曲线（Path）  </li>
<li>    canvas.drawPath(path, paintQ);  </li>
<li>}  </li>
</ol>
<p> <br />
<br />最后是用户触屏监听函数以及逻辑函数：</p>
<p><strong>[c-sharp]</strong> <a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>/** </li>
<li> * 触屏事件监听 </li>
<li> */  </li>
<li>@Override  </li>
<li>public boolean onTouchEvent(MotionEvent event) {  </li>
<li>    endX = (int) event.getX();  </li>
<li>    endY = (int) event.getY();  </li>
<li>    return true;  </li>
<li>}  </li>
<li>/** </li>
<li> * 游戏逻辑 </li>
<li> */  </li>
<li>private void logic() {  </li>
<li>    if (endX != 0 &amp;&amp; endY != 0) {  </li>
<li>        // 设置操作点为线段x/y的一半  </li>
<li>        controlX = random.nextInt((endX - startX) / 2);  </li>
<li>        controlY = random.nextInt((endY - startY) / 2);  </li>
<li>    }  </li>
<li>}  </li>
</ol>
<p> <br />
<br /> </p>
<p> </p>
<p>整个代码很easy～主要是贝赛尔函数的参数，尤其是操作点，操作点的各种不同可以实现不同的效果，这里我简单的统一的讲操作点设置成用户触屏点的x,y的一半，呵呵偷懒了～嘻嘻～</p>
<p>我把贝赛尔的操作点写在了逻辑logic（）函数中，不断的执行，并且每次利用nextInt函数得到随机的操作点，主要为了让其曲线不断的变化从而形成一个震动的曲线运动轨迹；</p>
<p> </p>
<p>ok，效果接图如下：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDExMDYvMjAvNzIxMTI1M18xMzA4NTM5NjM2aDhwWS5qcGc=.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDExMDYvMjAvNzIxMTI1M18xMzA4NTM5NjM1RkN3Vy5qcGc=.jpg"></p>
<p> </p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDExMDYvMjAvNzIxMTI1M18xMzA4NTM5NjM5OGVvRS5qcGc=.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaGkuY3Nkbi5uZXQvYXR0YWNobWVudC8yMDExMDYvMjAvNzIxMTI1M18xMzA4NTM5NjM3emNDbC5qcGc=.jpg"></p>
<p> </p>
<p>     这里可能由于图片是静止的效果看起来不是很明显，大家可以运行源码来观察 ，好了～本节就这样吧；下面贴出整个MySurfaceView的源码：（最后有本项目的源码下载地址）</p>
<p><strong>[java]</strong> <a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/xiaominghimi/article/details/6555828#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>package com.qpath;  </li>
<li>import java.util.Random;  </li>
<li>import android.content.Context;  </li>
<li>import android.graphics.Canvas;  </li>
<li>import android.graphics.Color;  </li>
<li>import android.graphics.Paint;  </li>
<li>import android.graphics.Paint.Style;  </li>
<li>import android.graphics.Path;  </li>
<li>import android.view.KeyEvent;  </li>
<li>import android.view.MotionEvent;  </li>
<li>import android.view.SurfaceHolder;  </li>
<li>import android.view.SurfaceHolder.Callback;  </li>
<li>import android.view.SurfaceView;  </li>
<li>/** </li>
<li> * 赛贝尔曲线 </li>
<li> * @author Himi </li>
<li> *  </li>
<li> */  </li>
<li>public class MySurfaceView extends SurfaceView implements Callback, Runnable {  </li>
<li>    private SurfaceHolder sfh;  </li>
<li>    private Paint paint;  </li>
<li>    private Thread th;  </li>
<li>    private boolean flag;  </li>
<li>    private Canvas canvas;  </li>
<li>    public static int screenW, screenH;  </li>
<li>    // -----------以上是SurfaceView游戏框架  </li>
<li>    // 贝赛尔曲线成员变量(起始点，控制（操作点），终止点，3点坐标)  </li>
<li>    private int startX, startY, controlX, controlY, endX, endY;  </li>
<li>    // Path  </li>
<li>    private Path path;  </li>
<li>    // 为了不影响主画笔，这里绘制贝赛尔曲线单独用一个新画笔  </li>
<li>    private Paint paintQ;  </li>
<li>    // 随机库（让贝赛尔曲线更明显）  </li>
<li>    private Random random;  </li>
<li>    /** </li>
<li>     * SurfaceView初始化函数 </li>
<li>     */  </li>
<li>    public MySurfaceView(Context context) {  </li>
<li>        super(context);  </li>
<li>        sfh = this.getHolder();  </li>
<li>        sfh.addCallback(this);  </li>
<li>        paint = new Paint();  </li>
<li>        paint.setColor(Color.WHITE);  </li>
<li>        paint.setAntiAlias(true);  </li>
<li>        setFocusable(true);  </li>
<li>        // -----------以上是SurfaceView游戏框架  </li>
<li>        //贝赛尔曲线相关初始化  </li>
<li>        path = new Path();  </li>
<li>        paintQ = new Paint();  </li>
<li>        paintQ.setAntiAlias(true);  </li>
<li>        paintQ.setStyle(Style.STROKE);  </li>
<li>        paintQ.setStrokeWidth(5);  </li>
<li>        paintQ.setColor(Color.WHITE);  </li>
<li>        random = new Random();  </li>
<li>    }  </li>
<li>    /** </li>
<li>     * SurfaceView视图创建，响应此函数 </li>
<li>     */  </li>
<li>    public void surfaceCreated(SurfaceHolder holder) {  </li>
<li>        screenW = this.getWidth();  </li>
<li>        screenH = this.getHeight();  </li>
<li>        flag = true;  </li>
<li>        // 实例线程  </li>
<li>        th = new Thread(this);  </li>
<li>        // 启动线程  </li>
<li>        th.start();  </li>
<li>        // -----------以上是SurfaceView游戏框架  </li>
<li>    }  </li>
<li>    /** </li>
<li>     * 游戏绘图 </li>
<li>     */  </li>
<li>    public void myDraw() {  </li>
<li>        try {  </li>
<li>            canvas = sfh.lockCanvas();  </li>
<li>            if (canvas != null) {  </li>
<li>                canvas.drawColor(Color.BLACK);  </li>
<li>                // -----------以上是SurfaceView游戏框架  </li>
<li>                drawQpath(canvas);  </li>
<li>            }  </li>
<li>        } catch (Exception e) {  </li>
<li>            // TODO: handle exception  </li>
<li>        } finally {  </li>
<li>            if (canvas != null)  </li>
<li>                sfh.unlockCanvasAndPost(canvas);  </li>
<li>        }  </li>
<li>    }  </li>
<li>    /** </li>
<li>     * 绘制贝赛尔曲线 </li>
<li>     *  </li>
<li>     * @param canvas 主画布 </li>
<li>     */  </li>
<li>    public void drawQpath(Canvas canvas) {  </li>
<li>        path.reset();// 重置path  </li>
<li>        // 贝赛尔曲线的起始点  </li>
<li>        path.moveTo(startX, startY);  </li>
<li>        // 设置贝赛尔曲线的操作点以及终止点  </li>
<li>        path.quadTo(controlX, controlY, endX, endY);  </li>
<li>        // 绘制贝赛尔曲线（Path）  </li>
<li>        canvas.drawPath(path, paintQ);  </li>
<li>    }  </li>
<li>    /** </li>
<li>     * 触屏事件监听 </li>
<li>     */  </li>
<li>    @Override  </li>
<li>    public boolean onTouchEvent(MotionEvent event) {  </li>
<li>        endX = (int) event.getX();  </li>
<li>        endY = (int) event.getY();  </li>
<li>        return true;  </li>
<li>    }  </li>
<li>    /** </li>
<li>     * 游戏逻辑 </li>
<li>     */  </li>
<li>    private void logic() {  </li>
<li>        if (endX != 0 &amp;&amp; endY != 0) {  </li>
<li>            // 设置操作点为线段x/y的一半  </li>
<li>            controlX = random.nextInt((endX - startX) / 2);  </li>
<li>            controlY = random.nextInt((endY - startY) / 2);  </li>
<li>        }  </li>
<li>    }  </li>
<li>    /** </li>
<li>     * 按键事件监听 </li>
<li>     */  </li>
<li>    @Override  </li>
<li>    public boolean onKeyDown(int keyCode, KeyEvent event) {  </li>
<li>        return super.onKeyDown(keyCode, event);  </li>
<li>    }  </li>
<li>    public void run() {  </li>
<li>        while (flag) {  </li>
<li>            long start = System.currentTimeMillis();  </li>
<li>            myDraw();  </li>
<li>            logic();  </li>
<li>            long end = System.currentTimeMillis();  </li>
<li>            try {  </li>
<li>                if (end - start &lt; 50) {  </li>
<li>                    Thread.sleep(50 - (end - start));  </li>
<li>                }  </li>
<li>            } catch (InterruptedException e) {  </li>
<li>                e.printStackTrace();  </li>
<li>            }  </li>
<li>        }  </li>
<li>    }  </li>
<li>    /** </li>
<li>     * SurfaceView视图状态发生改变，响应此函数 </li>
<li>     */  </li>
<li>    public void surfaceChanged(SurfaceHolder holder, int format, int width,  </li>
<li>            int height) {  </li>
<li>    }  </li>
<li>    /** </li>
<li>     * SurfaceView视图消亡时，响应此函数 </li>
<li>     */  </li>
<li>    public void surfaceDestroyed(SurfaceHolder holder) {  </li>
<li>        flag = false;  </li>
<li>    }  </li>
<li>} </li>
</ol>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 09:50:42</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>android画图之贝塞尔曲线讲解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZPEwz.html" rel="bookmark">Android Path绘制贝塞尔曲线实现QQ拖拽泡泡&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这两天学习了使用Path绘制贝塞尔曲线相关,然后自己动手做了一个类似QQ未读消息可拖拽的小气泡,效果图如下: 最终效果图 接下来一步一步的实现整个过程. 基本原理 其实就是使用Path绘制三点的二次方贝塞尔曲线来完成那个妖娆的曲线的.然后根据触摸点不断绘制对应的圆形,根据距离的改变改变原始固定圆形的半径大小.最后就是松手后返回或者爆裂的实现. Path介绍: 顾名思义,就是一个路径的意思,Path里面有很多的方法,本次设计主要用到的相关方法有 moveTo() 移动Path到一个指定的点 qua			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxE7yOp.html" rel="bookmark">Android中贝塞尔曲线的绘制方法示例代码&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				       贝塞尔曲线,很多人可能不太了解,什么叫做贝塞尔曲线呢?这里先做一下简单介绍:贝塞尔曲线也可以叫做贝济埃曲线或者贝兹曲线,它由线段与节点组成,节点是可拖动的支点,线段像可伸缩的皮筋.一般的矢量图形软件常利用贝塞尔曲线来精确画出曲线.        上面的介绍中,&quot;线段像可伸缩的皮筋&quot;这句话非常关键,但也特别好理解.至于贝塞尔曲线的详细内容大家可以查阅相关资料.        Android提供的贝塞尔曲线绘制接口        在Android开发中,要实现贝塞尔曲线其实还			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKdAB7M.html" rel="bookmark">Android中贝塞尔曲线的绘制方法示例代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				贝塞尔曲线,很多人可能不太了解,什么叫做贝塞尔曲线呢?这里先做一下简单介绍:贝塞尔曲线也可以叫做贝济埃曲线或者贝兹曲线,它由线段与节点组成,节点是可拖动的支点,线段像可伸缩的皮筋.一般的矢量图形软件常利用贝塞尔曲线来精确画出曲线. 上面的介绍中,&quot;线段像可伸缩的皮筋&quot;这句话非常关键,但也特别好理解.至于贝塞尔曲线的详细内容大家可以查阅相关资料. Android提供的贝塞尔曲线绘制接口 在Android开发中,要实现贝塞尔曲线其实还是很简单的,因为Android已经给我们提供了相关接口,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M694jyb.html" rel="bookmark">Android贝塞尔曲线初步学习第二课 仿QQ未读消息气泡拖拽黏连效果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一节初步了解了Android端的贝塞尔曲线,这一节就举个栗子练习一下,仿QQ未读消息气泡,是最经典的练习贝塞尔曲线的东东,效果如下 附上github源码地址:https://github.com/MonkeyMushroom/DragBubbleView 欢迎star~ 大体思路就是画两个圆,一个黏连小球固定在一个点上,一个气泡小球跟随手指的滑动改变坐标.随着两个圆间距越来越大,黏连小球半径越来越小.当间距小于一定值,松开手指气泡小球会恢复原来位置:当间距超过一定值之后,黏连小球消失,气泡小球			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGDkwp.html" rel="bookmark">AE贝塞尔曲线制作弹性动画</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  在使用贝塞尔曲线制作弹性动画前我们先来了解贝塞尔曲线实现原理,来理解什么是符合物理运动规律的动画效果 Android L开始在动效实现方法上有了飞跃提升,散乱的动画效果主要是没有统一的理论支撑,终于在android L之后贝塞尔曲线和SVG动画的普遍使用,使得android原生系统的动效设计成为宣传的一大亮点. 这里重点说一下贝塞尔曲线.很多人一听起来觉得是一个特别专业的词语,其实不然,学过设计或有绘图软件基础的同学接下来都能理解贝塞尔曲线的原理. 在百度百科里面的解释是:&quot;贝赛尔&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyRkPp.html" rel="bookmark">Android自定义View之使用贝塞尔曲线实现流量进度条</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一次写带图片的博客,多少还是有点紧张,效果不好,请将就着看,前面的图是今天要写的控件的效果图,元素不多,分别是一个按钮和一个自定义的控件. 在此以前,我看过许多的书,比如&lt;Android群英传&gt;.&lt;第一行代码&gt;等,也看了很多大神的博客,但是即便是这样,当我看到这么多代码的时候,一直都没有真正的动手去敲过这些代码,以至于我总是觉得自定义View是一个多么高深莫测的技术,我们这些小白是难以触及的,但是当昨晚看了一篇鸡汤之后,觉得人还是要学会专注,要耐得住寂寞,要沉得住气.所以在未来的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrPk3p.html" rel="bookmark">Android把商品添加到购物车的动画效果（贝塞尔曲线）&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当我们写商城类的项目的时候,一般都会有加入购物车的功能,加入购物车的时候会有一些抛物线动画,具体代码如下: 实现效果如图: 思路: 确定动画的起终点 在起终点之间使用二次贝塞尔曲线填充起终点之间的点的轨迹 设置属性动画,ValueAnimator插值器,获取中间点的坐标 将执行动画的控件的x.y坐标设为上面得到的中间点坐标 开启属性动画 当动画结束时的操作 难点: PathMeasure的使用 - getLength() - boolean getPosTan(float distance, f			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeawl0z.html" rel="bookmark">android中贝塞尔曲线的应用示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言: 贝塞尔曲线又称贝兹曲线,它的主要意义在于无论是直线或曲线都能在数学上予以描述.最初由保罗·德卡斯特里奥(Paul de Casteljau)于1959年运用德卡斯特里奥演算法开发(de Casteljau Algorithm),在1962,由法国工程师皮埃尔·贝塞尔(Pierre Bézier)所广泛发表.目前广泛应用于图形绘制领域来模拟光滑曲线,为计算机矢量图形学奠定了基础.在一些图形处理软件中都能见到贝塞尔曲线,比如CorelDraw中翻译成&quot;贝赛尔工具&quot;:而在Firewo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEEk36b.html" rel="bookmark">Android把商品添加到购物车的动画效果（贝塞尔曲线）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				当我们写商城类的项目的时候,一般都会有加入购物车的功能,加入购物车的时候会有一些抛物线动画,具体代码如下: 实现效果如图: 思路: 确定动画的起终点 在起终点之间使用二次贝塞尔曲线填充起终点之间的点的轨迹 设置属性动画,ValueAnimator插值器,获取中间点的坐标 将执行动画的控件的x.y坐标设为上面得到的中间点坐标 开启属性动画 当动画结束时的操作 难点: PathMeasure的使用 - getLength() - boolean getPosTan(float distance, f			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMy72Pz.html" rel="bookmark" class="title">如何让百度重新收录我的网站</a>
					<div>
						今天是2012年11月9日,网站真正被K的第2个月零9天.今天从家里吃晚饭回到学校已经10点多了,拖着疲惫的身体打开电脑,按照惯例,每次上网我都会查询一次网站的收录情况,虽然这是完全没有必要的,但是我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPRxmb.html" rel="bookmark" class="title">Hibernate映射文件打成jar，JUnit测试无法正确执行的问题分析</a>
					<div>
						之前将Hibernate的实体类及其映射文件也放到项目中,由于有多个项目使用同一个数据库, Hibernate实体类和映射文件重复,不便于维护和升级.因此将其抽取出来,打成jar包,再引入回项目. 实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk22LdM.html" rel="bookmark" class="title">Javascript继承（下） 为何要继承</a>
					<div>
						Quiz1 Javascript真的需要类(Class)么? 我们首先先看下其他有类(Class)的面向对象语言(如: Java)的一些特性. 父类与子类 父类(Superclass)和子类(Subc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AZ0qp.html" rel="bookmark" class="title">Windows Vista SP1新增创建恢复盘功能</a>
					<div>
						首先,SP1的确有非常显著的性能增强,代码已经被优化.有趣的是这个SP1仍然有随更新源代码嵌入的微软内部网络共享标记,如: \\winbuilds3\longhorn_SP1Beta1\longhor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAn00b.html" rel="bookmark" class="title">Android的ToDoList&lpar;fragment&rpar; 详解</a>
					<div>
						Fragment(碎片) 可以灵活地从一个活动的Activity上添加或删除Fragment, 有良好的用户体验; 下面是Fragment的具体设计: 1. 创建new_item_fragment的资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnrAlz.html" rel="bookmark" class="title">Win8系统无线连接经常受限状态怎么处理？</a>
					<div>
						  Win8系统无线连接经常受限状态怎么处理?         1.右击我的计算机---属性---设备管理,找到我们的无线网卡,然后右击选择属性. 2.将无线网卡属性,高级选项卡那个地方 802.11 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ADwqp.html" rel="bookmark" class="title">在JavaScript中使用开平方根的sqrt&lpar;&rpar;方法</a>
					<div>
						  这篇文章主要介绍了在JavaScript中使用开平方根的sqrt()方法,是JS入门学习中的基础知识,需要的朋友可以参考下 这个方法返回一个数的平方根.如果数的值是负的,开方返回NaN. 语法 ? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yqo3z.html" rel="bookmark" class="title">ps绘制蓝色光感图标</a>
					<div>
						  蓝色光感图标效果图: 下面就是教程的详细操作步骤: 步骤一.新建一个文件图层,将背景内容设置为透明色,如图所示: 步骤二.将图层1的的前景色填充为&quot;373737&quot;的参数,然后在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjBylb.html" rel="bookmark" class="title">阿云浏览器如何关闭&OpenCurlyDoubleQuote;打开多个标签页时关闭浏览器&rdquo;的自动提醒</a>
					<div>
						  用户可以打开&quot;阿云浏览器设置&quot;,在&quot;常用设置&quot;下的&quot;自动提醒&quot;中,取消勾选&quot;打开多个标签时关闭浏览器&quot;即可,如下图所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mywox4z.html" rel="bookmark" class="title">银狐库存管家库存同步&sol;库存发布图文教程</a>
					<div>
						  在淘宝网店上进行库存控制是件非常痛苦和无奈的事情,特别是有多个分店的情况,根本是不可能完成的任务,银狐的核心思路是以本地软件库存为基础,通过严格进出库控制,保证本地库存的准确性;然后通过库存同步功 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJ52op.html" rel="bookmark" class="title">如何在32位系统下安装64位系统</a>
					<div>
						  在论坛看到很多网友提问说32位系统下无法安装64位Windows7系统,这里推荐一个很简单的方法来在32位系统下安装64位系统. 32位系统可以是任意,比如XP,Vista,Windows7的32 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwKlnb.html" rel="bookmark" class="title">关于日期正则表达式的思路详解</a>
					<div>
						1        概述 首先需要说明的一点,无论是Winform,还是Webform,都有很成熟的日历控件,无论从易用性还是可扩展性上看,日期的选择和校验还是用日历控件来实现比较好. 前几天在CSDN ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6EXDz.html" rel="bookmark" class="title">AI蓬勃发展推动NVIDIA第三财季轻松超预期</a>
					<div>
						Nvidia将继续推动芯片产业的发展,由于其面向人工智能应用的芯片业务蓬勃发展,Nvidia在第三财季的表现轻松超出了预期. Nvidia公布财报称,该季度利润为8.38亿美元(或者每股1.33美元) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj9Llp.html" rel="bookmark" class="title">滚轮事件-怎么使鼠标滚轮每次滚动自定义距离？</a>
					<div>
						问题描述 怎么使鼠标滚轮每次滚动自定义距离? 比如每次滚动鼠标鼠标滚轮页面向下滑动700px,并且获得滚动事件.具体网页可看 亲宝宝 的pc端官网~大神们求教~ 解决方案 如何自定义鼠标滚动时窗口滚动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7QaNp.html" rel="bookmark" class="title">ios-IOS&amp;amp&semi;amp&semi;amp&semi;Android开发：如何从大量未加载的数据中加载一定量的数据到列表中</a>
					<div>
						问题描述 IOS&amp;Android开发:如何从大量未加载的数据中加载一定量的数据到列表中 绝大多数新闻资讯类应用开发过程中都会遇到这么一个问题: 规定每次从服务器最多只能获取20条数据,第一次刷 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOleV3b.html" rel="bookmark" class="title">VMware、Pivotal和Google Cloud协力推出全新基于Kubernetes的容器服务&mdash;&mdash;Pivotal Container Service（PKS）</a>
					<div>
						本文讲的是VMware.Pivotal和Google Cloud协力推出全新基于Kubernetes的容器服务--Pivotal Container Service(PKS)[编者的话]定制化应用不再 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2ROXb.html" rel="bookmark" class="title">百度翻译上线 首次提供千字免费翻译服务</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 7月10日消息,近日百度正式推出了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjl95p.html" rel="bookmark" class="title">P2P平台面临的信息安全问题与应对策略</a>
					<div>
						P2P网络贷款是近年来新兴的一种互联网金融模式,是一种个体和个体之间通过互联网平台实现的直接借贷.P2P网贷平台则为借贷双方提供信息流通交互.撮合.资信评估.投资咨询.法律手续办理等中介服务.近两年来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRq0R8b.html" rel="bookmark" class="title">使用哪种循环else里的东西只执行一次</a>
					<div>
						问题描述 DataTableSS=数据源:for(intiii=0;iii&gt;SS.Rows.Count;iii++){stringAB=SS.Rows[iii][&quot;ID&quot;]. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmDErb.html" rel="bookmark" class="title">《Access 2007开发指南&lpar;修订版&rpar;》一一1&period;7　硬件要求</a>
					<div>
						1.7 硬件要求 Access 2007开发指南(修订版) Aceess的一个不足之处就在于它对硬件资源的要求太高.这种要求对开发人员和最终用户来说是不一样的,因此,将系统要求分成两个部分来讨论.当用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJGg9p.html" rel="bookmark" class="title">myeclipse 111111111111111111111111</a>
					<div>
						问题描述 myeclipse 111111111111111111111111 运行main方法 出现问题 控制台打印出 为什么呀1 解决方案 就是说,要运行这个程序,需要执行: java FrpJp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBYwwz.html" rel="bookmark" class="title">ListView搜索数据咋整？</a>
					<div>
						问题描述 ListView用的是高效分页,就是这种方法:http://www.cnblogs.com/La5DotNet/archive/2012/05/07/2489382.html那么问题来了,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4elALb.html" rel="bookmark" class="title">JMenu弹出子菜单时候，如何动态的设置延迟？</a>
					<div>
						问题描述 项目中遇到一个问题,现在有一个JMenu,初始的时候没有子菜单.在另外一个线程中做了一系列的操作后,会取到子菜单的信息,这个时候把相关信息添加上去.当中可能会消耗几秒时间.要达到的效果是类似 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7BDYz.html" rel="bookmark" class="title">站长初体验新版百度统计</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 今早(7月21日)在搜狐IT新闻上看到百度公司宣布正式推出&quot;百度统计&quot;系统,不过现阶段只针对百度的企业客户免费开放.官方介绍说百度统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXK8VlM.html" rel="bookmark" class="title">JS生成随机字符串的多种方法&lowbar;javascript技巧</a>
					<div>
						下面的一段代码,整理电脑时,记录备查. 复制代码 代码如下: &lt;script language=&quot;javascript&quot;&gt; function randomString( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlGBmp.html" rel="bookmark" class="title">myeclipse 2015打开tomcat遇到问题</a>
					<div>
						问题描述 myeclipse 2015打开tomcat遇到问题 myeclipse2015启动不了tomcat求解释一下啊,问题就像图片里的一样,启动是遇到内部错误,是不是我的路径不太对啊 解决方案  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqWxEZz.html" rel="bookmark" class="title">asp&period;net 1&period;1与2&period;0的版本冲突</a>
					<div>
						问题描述 大家好:请大家帮帮忙,我有个web服务器,同时运行个网站程序和WebServices接口服务程序,配制好后运行正常,但每运行1~2天后整个IIS服务器都瘫痪了,重新启动计算机后运行正常随后又 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkNl9M.html" rel="bookmark" class="title">OpenStack董事选举结果出炉 新浪程辉入围</a>
					<div>
						问题描述 OpenStackFoundation董事会第一次会议,选举结果出炉:SUSE的AlanClark当选董事会主席,RackSpace的JonathanBryce将出任基金会CEO.新浪程辉以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zG1N2nM.html" rel="bookmark" class="title">云监控 Dashboard上线啦~！</a>
					<div>
						手里一坨机器,想一眼看尽相关主机的CPU.网络.内存.磁盘性能怎么办?! 人手不够,缺想做大屏展示,24小时动态监控机器性能怎么办?! 老板骂我浪费资源,如何证明我真的物有所用? 来来来~!所有这些问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRqlBz.html" rel="bookmark" class="title">Sql Server函数全解&amp;lt&semi;五&amp;gt&semi;之系统函数</a>
					<div>
						原文:Sql Server函数全解&lt;五&gt;之系统函数  系统信息包括当前使用的数据库名称,主机名,系统错误消息以及用户名称等内容.使用SQL SERVER中的系统函数可以在需要的时候获取这些 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
